From 4cbdd4075c9b50820da4a954f6d2b806a2997e07 Mon Sep 17 00:00:00 2001
From: Amul Sul <amul.sul@enterprisedb.com>
Date: Tue, 13 Dec 2022 10:52:29 +0530
Subject: [PATCH v1 04/25] Change brin_bloom_summary_in to allow non-throw
 error reporting

---
 src/backend/access/brin/brin_bloom.c      |  2 +-
 src/test/regress/expected/type_sanity.out | 12 ++++++++++++
 src/test/regress/sql/type_sanity.sql      |  3 +++
 3 files changed, 16 insertions(+), 1 deletion(-)

diff --git a/src/backend/access/brin/brin_bloom.c b/src/backend/access/brin/brin_bloom.c
index 6b0af7267d5..883802cb5d9 100644
--- a/src/backend/access/brin/brin_bloom.c
+++ b/src/backend/access/brin/brin_bloom.c
@@ -745,7 +745,7 @@ brin_bloom_summary_in(PG_FUNCTION_ARGS)
 	 * brin_bloom_summary stores the data in binary form and parsing text
 	 * input is not needed, so disallow this.
 	 */
-	ereport(ERROR,
+	ereturn(fcinfo->context, (Datum) 0,
 			(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
 			 errmsg("cannot accept a value of type %s", "pg_brin_bloom_summary")));
 
diff --git a/src/test/regress/expected/type_sanity.out b/src/test/regress/expected/type_sanity.out
index b2bc0205a76..95aa04e69ef 100644
--- a/src/test/regress/expected/type_sanity.out
+++ b/src/test/regress/expected/type_sanity.out
@@ -796,3 +796,15 @@ SELECT pg_input_error_message('pg_monitor=rY', 'aclitem');
  invalid mode character: must be one of "arwdDxtXUCTcsAvz"
 (1 row)
 
+SELECT pg_input_is_valid('1', 'pg_brin_bloom_summary');
+ pg_input_is_valid 
+-------------------
+ f
+(1 row)
+
+SELECT pg_input_error_message('1', 'pg_brin_bloom_summary');
+               pg_input_error_message                
+-----------------------------------------------------
+ cannot accept a value of type pg_brin_bloom_summary
+(1 row)
+
diff --git a/src/test/regress/sql/type_sanity.sql b/src/test/regress/sql/type_sanity.sql
index 080ac15b6c8..a75f6abfd27 100644
--- a/src/test/regress/sql/type_sanity.sql
+++ b/src/test/regress/sql/type_sanity.sql
@@ -596,3 +596,6 @@ SELECT pg_input_is_valid('pg_monitor=r/', 'aclitem');
 SELECT pg_input_error_message('pg_monitor=r/', 'aclitem');
 SELECT pg_input_is_valid('pg_monitor=rY', 'aclitem');
 SELECT pg_input_error_message('pg_monitor=rY', 'aclitem');
+
+SELECT pg_input_is_valid('1', 'pg_brin_bloom_summary');
+SELECT pg_input_error_message('1', 'pg_brin_bloom_summary');
-- 
2.18.0

